<?php

namespace app\models\mikrotik\mpls\mpls;

use yii\base\Model;
use Yii;

require_once 'PEAR2_Net_RouterOS-1.0.0b5.phar';

use PEAR2\Net\RouterOS;
use app\models\mikrotik\MikrotikConnect;

class Ldpfilter extends Model {

    public $id;
    public $prefix;
    public $neighbor;
    public $accept;
    public $disabled;

    public function rules() {
        return [
            ['id', 'string'],
            ['prefix', 'string'],
            ['neighbor', 'string'],
            ['accept', 'string'],
            ['disabled', 'string'],
        ];
    }

    public function getAll() {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/mpls/ldp/accept-filter/getall');
        $responses = $connect->getConnection()->sendSync($getRequest);
        $return = array();
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $c = new Ldpfilter();
                $c->id = $response->getProperty('.id');
                $c->prefix = $response->getProperty('prefix');
                $c->neighbor = $response->getProperty('neighbor');
                $c->accept = $response->getProperty('accept');
                $c->disabled = $response->getProperty('disabled');
                $return[] = $c;
            }
        }
        return $return;
    }

    public function get($id) {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/mpls/ldp/accept-filter/print');
        $getRequest->setQuery(RouterOS\Query::where('.id', $id));
        $responses = $connect->getConnection()->sendSync($getRequest);
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $this->id = $response->getProperty('.id');
                $this->prefix = $response->getProperty('prefix');
                $this->neighbor = $response->getProperty('neighbor');
                $this->accept = (($response->getProperty('accept') == 'true') ? true : false);
                $this->disabled = (($response->getProperty('disabled') == 'true') ? true : false);
            }
        }
        return;
    }

    public function update($id) {
        $c = new Ldpfilter();
        $c->get($id);
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/mpls/ldp/accept-filter/set');
        $setRequest->setargument('.id', $id);
        if ($this->prefix != $c->prefix) {
            $setRequest->setargument('prefix', $this->prefix);
        }
        if ($this->neighbor != $c->neighbor) {
            $setRequest->setargument('neighbor', $this->neighbor);
        }
        $setRequest->setargument('accept', (($this->accept == true) ? "true" : "false"));

        if (isset($unset)) {
            $unsetRequest = new RouterOS\Request('/mpls/ldp/accept-filter/unset');
            foreach ($unset as $value) {
                $unsetRequest->setArgument('.id', $id);
                $unsetRequest->setArgument('value-name', $value);
                $resp = $connect->getConnection()->sendSync($unsetRequest);
                if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
                    if (!isset($re)) {
                        $re = '';
                    } $re.= ' ' . $resp->getProperty('message');
                }
            }
        } $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            if (isset($re)) {
                $re.= ' ' . $resp->getProperty('message');
            } else {
                $re = $resp->getProperty('message');
            }
        } if (isset($re)) {
            return $re;
        } else {
            return '1';
        }
    }

    public function disable($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/mpls/ldp/accept-filter/disable');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function enable($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/mpls/ldp/accept-filter/enable');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function create() {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/mpls/ldp/accept-filter/add');

        if ($this->prefix != "") {
            $setRequest->setargument('prefix', $this->prefix);
        }
        if ($this->neighbor != "") {
            $setRequest->setargument('neighbor', $this->neighbor);
        }
        if ($this->accept != "") {
            $setRequest->setargument('accept', (($this->accept == true) ? "true" : "false"));
        }

        $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            return $resp->getProperty('message');
        } else {
            return '1';
        }
    }

    public function delete($id) {
        $connect = MikrotikConnect::Instance();
        $util = new RouterOS\Util($connect->getConnection());
        $util->setMenu('/mpls/ldp/accept-filter');
        $util->remove(RouterOS\Query::where('.id', $id));
        return;
    }

}
